"""init db

修订 ID: 557fef3a156f
父修订:
创建时间: 2023-10-10 18:16:41.811561

"""
from __future__ import annotations

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

revision: str = "557fef3a156f"
down_revision: str | Sequence[str] | None = None
branch_labels: str | Sequence[str] | None = ("nonebot_plugin_wordcloud",)
depends_on: str | Sequence[str] | None = None


def upgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "nonebot_plugin_wordcloud_schedule",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column(
            "target",
            sa.JSON().with_variant(postgresql.JSONB(), "postgresql"),
            nullable=False,
        ),
        sa.Column("time", sa.Time(), nullable=True),
        sa.PrimaryKeyConstraint(
            "id", name=op.f("pk_nonebot_plugin_wordcloud_schedule")
        ),
    )
    # ### end Alembic commands ###


def downgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("nonebot_plugin_wordcloud_schedule")
    # ### end Alembic commands ###
